- introduce variable _BB_CONFIG_DEP to the new test harness.

This is used to see if given tests should be run (are available) or not.
  Print "UNTESTED: descr" if the applet or feature is not available.
- add _BB_CONFIG_DEP to existing new.tests
- move old grep test to new test infrastructure and add a few more test for
  grep.
This commit is contained in:
Bernhard Reutner-Fischer 2005-09-23 15:44:46 +00:00
parent 0a44c17771
commit b47a74f4e7
13 changed files with 137 additions and 22 deletions

View File

@ -7,6 +7,9 @@
if [ ${#COMMAND} -eq 0 ]; then COMMAND=busybox; fi
. testing.sh
# Depends on nothing
_BB_CONFIG_DEP=""
# We'll assume "cat" is built in, because we need some other command to test.
HELPDUMP=`$COMMAND`

20
testsuite/egrep.tests Executable file
View File

@ -0,0 +1,20 @@
#!/bin/sh
# egrep tests.
# Copyright 2005 by Rob Landley <rob@landley.net>
# Licensed under GPL v2, see file LICENSE for details.
# AUDIT:
[ ${#COMMAND} -eq 0 ] && COMMAND=egrep
. testing.sh
# Depends on FEATURE_GREP_EGREP_ALIAS
_BB_CONFIG_DEP=FEATURE_GREP_EGREP_ALIAS
testing "grep is also egrep" "foo" "foo\n" "" "foo\nbar\n"
testing "egrep is not case insensitive" "foo ; [ \$? -ne 0 ] && echo yes" \
"yes\n" "" "FOO\n"
exit $FAILCOUNT

82
testsuite/grep.tests Normal file
View File

@ -0,0 +1,82 @@
#!/bin/sh
# grep tests.
# Copyright 2005 by Rob Landley <rob@landley.net>
# Licensed under GPL v2, see file LICENSE for details.
# AUDIT:
[ ${#COMMAND} -eq 0 ] && COMMAND=grep
. testing.sh
# Depends on grep
_BB_CONFIG_DEP=grep
# testing "test name" "options" "expected result" "file input" "stdin"
# file input will be file called "input"
# test can create a file "actual" instead of writing to stdout
# Test exit status
testing "grep (exit with error)" "nonexistent 2> /dev/null ; echo \$?" \
"1\n" "" ""
testing "grep (exit success)" "grep $0 > /dev/null 2>&1 ; echo \$?" "0\n" \
"" ""
# Test various data sources and destinations
testing "grep (default to stdin)" "two" "two\n" "" \
"one\ntwo\nthree\nthree\nthree\n"
testing "grep - (specify stdin)" "two -" "two\n" "" \
"one\ntwo\nthree\nthree\nthree\n"
testing "grep input (specify file)" "two input" "two\n" \
"one\ntwo\nthree\nthree\nthree\n" ""
# Note that this assumes actual is empty.
testing "grep input actual (two files)" "two input actual 2> /dev/null" \
"input:two\n" "one\ntwo\nthree\nthree\nthree\n" ""
testing "grep - infile (specify stdin and file)" "two - input" \
"(standard input):two\ninput:two\n" "one\ntwo\nthree\n" \
"one\ntwo\ntoo\nthree\nthree\n"
# Check if we see the correct return value if both stdin and non-existing file
# are given.
testing "grep - nofile (specify stdin and nonexisting file)" \
"two - nonexistent 2> /dev/null ; echo \$?" \
"(standard input):two\n(standard input):two\n2\n" \
"" "one\ntwo\ntwo\nthree\nthree\nthree\n"
testing "grep -q - nofile (specify stdin and nonexisting file, no match)" \
"-q nomatch - nonexistent 2> /dev/null ; echo \$?" \
"2\n" "" "one\ntwo\ntwo\nthree\nthree\nthree\n"
# SUSv3: If the -q option is specified, the exit status shall be zero
# if an input line is selected, even if an error was detected.
testing "grep -q - nofile (specify stdin and nonexisting file, match)" \
"-q two - nonexistent ; echo \$?" \
"0\n" "" "one\ntwo\ntwo\nthree\nthree\nthree\n"
# Test various command line options
# -s no error messages
testing "grep -s nofile (nonexisting file, no match)" \
"-s nomatch nonexistent ; echo \$?" "2\n" "" ""
testing "grep -s nofile - (stdin and nonexisting file, match)" \
"-s domatch nonexistent - ; echo \$?" "(standard input):domatch\n2\n" \
"" "nomatch\ndomatch\nend\n"
# This doesn't match GNU behaviour (Binary file input matches)
# acts like GNU grep -a
testing "grep handles binary files" "foo input" "foo\n" "\0foo\n\n" ""
# This doesn't match GNU behaviour (Binary file (standard input) matches)
# acts like GNU grep -a
testing "grep handles binary stdin" "foo" "foo\n" "" "\0foo\n\n"
testing "grep matches NUL" ". input > /dev/null 2>&1 ; echo \$?" "0\n" "\0\n" ""
# -e regex
testing "grep handles multiple regexps" "-e one -e two input ; echo \$?" \
"one\ntwo\n0\n" "one\ntwo\n" ""
# Depends on FEATURE_GREP_EGREP_ALIAS
_BB_CONFIG_DEP=FEATURE_GREP_EGREP_ALIAS
testing "grep -E supports extended regexps" "-E fo+" "foo\n" "" "b\ar\nfoo\nbaz"
exit $FAILCOUNT

View File

@ -1,2 +0,0 @@
# FEATURE: CONFIG_FEATURE_GREP_EGREP_ALIAS
test x`echo foo | busybox egrep FOO` = x

View File

@ -1,2 +0,0 @@
# FEATURE: CONFIG_FEATURE_GREP_EGREP_ALIAS
echo foo | busybox egrep fo+

View File

@ -1 +0,0 @@
echo -e '\0foo' | busybox grep foo

View File

@ -1 +0,0 @@
echo foo | busybox grep -e foo -e bar

View File

@ -1,2 +0,0 @@
# FEATURE: CONFIG_FEATURE_GREP_EGREP_ALIAS
echo foo | busybox egrep foo

View File

@ -1,8 +0,0 @@
set +e
echo -e '\0' | busybox grep .
if [ $? != 0 ] ; then
exit 0;
fi
exit 1;

View File

@ -90,21 +90,22 @@ else
fi
for applet in $applets; do
if [ "$applet" == links ]; then continue; fi
if [ "$applet" != CVS -a -d "$srcdir/$applet" ]; then
if [ "$applet" = "links" ]; then continue; fi
if [ "$applet" != "CVS" -a -d "$srcdir/$applet" ]; then
if run_applet_tests $applet; then
:
else
status=1
fi
fi
applet=`echo "$applet" | sed -n 's/\.tests$//p'`
if [ ${#applet} != 0 ]
applet=$(echo "$applet" | sed -n 's/\.tests$//p')
if [ ${#applet} -ne 0 ]
then
mkdir links 2>/dev/null
rm -f links/"$applet"
ln -s ${bindir:-../..}/busybox links/"$applet"
PATH="$srcdir:$PATH" COMMAND="links/$applet" "${srcdir:-.}/$applet".tests
PATH="$srcdir:$PATH" COMMAND="links/$applet" \
"${srcdir:-.}/$applet".tests
if [ $? -ne 0 ]; then status=1; fi
fi

View File

@ -7,6 +7,9 @@
if [ ${#COMMAND} -eq 0 ]; then COMMAND=sort; fi
. testing.sh
# Depends on sort
_BB_CONFIG_DEP=sort
# The basic tests. These should work even with the small busybox.
testing "sort" "input" "a\nb\nc\n" "c\na\nb\n" ""

View File

@ -28,9 +28,19 @@ fi
export FAILCOUNT=0
# Helper functions
config_is_set ()
{
local uc_what=$(echo ${1?} | tr a-z A-Z)
grep -q "^[ ]*CONFIG_${uc_what}" ${bindir:-..}/.config || \
grep -q "^[ ]*BB_CONFIG_${uc_what}" ${bindir:-..}/.config
return $?
}
# The testing function
function testing()
testing()
{
if [ $# -ne 5 ]
then
@ -38,6 +48,15 @@ function testing()
exit
fi
if [ ${force_tests:-0} -ne 1 -a -n "$_BB_CONFIG_DEP" ]
then
if ! config_is_set "$_BB_CONFIG_DEP"
then
echo "UNTESTED: $1"
return 0
fi
fi
f=$FAILCOUNT
echo -ne "$3" > expected
echo -ne "$4" > input

View File

@ -9,6 +9,9 @@
if [ ${#COMMAND} -eq 0 ]; then COMMAND=uniq; fi
. testing.sh
# Depends on uniq
_BB_CONFIG_DEP=uniq
# testing "test name" "options" "expected result" "file input" "stdin"
# file input will be file called "input"
# test can create a file "actual" instead of writing to stdout